package com.partisiablockchain.contract;

/*
 * Copyright (C) 2022 - 2023 Partisia Blockchain Foundation
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

import com.secata.stream.DataStreamSerializable;
import com.secata.stream.SafeDataInputStream;
import com.secata.stream.SafeDataOutputStream;
import java.util.function.Function;
import org.assertj.core.api.Assertions;

/**
 * Utility for verifying that serialization implementations are correct.
 *
 * <p>The properties checked are:
 *
 * <ul>
 *   <li>That object can be serialized to bytes.
 *   <li>That generated bytes can be deserialized.
 *   <li>That deserialized state is identical to original object.
 * </ul>
 *
 * <p>Verifiers are provided for both {@link DataStreamSerializable} objects, and for
 * direct-to/from-byte serialization.
 */
public final class SerializationChecker {
  private SerializationChecker() {}

  /**
   * Checks that given list of elements can be serialized ({@link DataStreamSerializable#write}) and
   * then deserialized into the same objects.
   *
   * <p>It is recommended that the {@code deserialize} method used is defined in the same class as
   * the {@link DataStreamSerializable#write} method, and is given the signature {@code public
   * static MyClass read(SafeDataInputStream stream)}.
   *
   * @param <T> Type of elements to serialize and deserialize.
   * @param deserialize method for deserializing the elements. Not nullable.
   * @param elements Elements to test using. Not nullable.
   */
  public static <T extends DataStreamSerializable> void assertSerializeDeserialize(
      Function<SafeDataInputStream, T> deserialize, Iterable<T> elements) {
    Assertions.assertThat(elements).isNotEmpty();
    assertSerializeDeserialize(
        v -> SafeDataOutputStream.serialize(v),
        b -> SafeDataInputStream.readFully(b, deserialize),
        elements);
  }

  /**
   * Checks that given list of elements can be serialized and then deserialized into the same
   * objects.
   *
   * <p>This expects direct-to/from-bytes serializations functions.
   *
   * @param <T> Type of elements to serialize and deserialize.
   * @param serialize method to serialize elements. Not nullable.
   * @param deserialize method to deserialize elements. Not nullable.
   * @param elements Elements to test using. Not nullable.
   */
  public static <T> void assertSerializeDeserialize(
      Function<T, byte[]> serialize, Function<byte[], T> deserialize, Iterable<T> elements) {
    for (final T element : elements) {
      final byte[] serialized = serialize.apply(element);
      final T deserialized = deserialize.apply(serialized);
      Assertions.assertThat(deserialized)
          .as("Write/read were not symmetric")
          .usingRecursiveComparison(StateSerializableEquality.ASSERTIONS_CONFIG_STATE_SERIALIZABLE)
          .isEqualTo(element);
    }
  }
}
